--- u-boot-2011.06_original/drivers/cnc1900/df/df_reg_fmt.h	1970-01-01 08:00:00.000000000 +0800
+++ u-boot-2011.06/drivers/cnc1900/df/df_reg_fmt.h	2014-07-29 17:28:38.819972000 +0800
@@ -0,0 +1,2161 @@
+#ifndef __DF_REG_FMT_H__
+#define __DF_REG_FMT_H__
+
+
+
+typedef struct _GLB
+{
+    union
+    {
+        struct
+        {
+            unsigned int wr_lb_limit:16;
+            unsigned int reserved:16;
+        }bits;
+
+        unsigned int val;
+    }reg_glb_ctrl_setting;
+	union
+	{
+		struct 
+		{
+			unsigned int clk_gate:5;
+			unsigned int reserved1:3;
+			unsigned int clk_en_sr:1;
+			unsigned int clk_en_main:1;
+			unsigned int clk_en_ui1:1;
+			unsigned int clk_en_ui2:1;
+			unsigned int clk_en_cap:1;
+			unsigned int clk_en_rd2:1;
+			unsigned int reserved2:19;
+		}bits;
+
+		unsigned int val;
+	}reg_glb_ctrl_clk_setting;
+    union
+    {
+        struct
+        {
+            unsigned int update_reg:1;
+            unsigned int reserved:31;
+        }bits;
+        unsigned int val;
+    }reg_glb_h_update;
+    union
+    {
+        struct
+        {
+            unsigned int update_reg:1;
+            unsigned int reserved:31;
+        }bits;
+        unsigned int val;
+    }reg_glb_m_update;
+    union
+    {
+        struct
+        {
+            unsigned int update_reg:1;
+            unsigned int reserved:31;
+        }bits;
+
+        unsigned int val;
+    }reg_glb_c_update;
+
+    union
+    {
+        struct
+        {
+            unsigned int cop_int_sta_disp1_err:1;
+            unsigned int cop_int_sta_disp2_err:1;
+            unsigned int cop_int_sta_cap_err:1;     
+            unsigned int cop_int_sta_disp1_sync:1;
+            unsigned int cop_int_sta_disp1_field:1;
+            unsigned int cop_int_sta_disp1_frame:1;
+            unsigned int cop_int_sta_disp2_frame:1;
+            unsigned int cop_int_sta_cap_finish:1;  
+            unsigned int cop_int_sta_main_f2f_finish:1;
+            unsigned int cop_int_sta_cap_change:1;
+            unsigned int reserved:22;
+        }bits;
+
+        unsigned int val;
+    }reg_glb_int_sta_cop;
+
+    union
+    {
+        struct
+        {
+            unsigned int cop_int_msk_disp1_err:1;
+            unsigned int cop_int_msk_disp2_err:1;
+            unsigned int cop_int_msk_cap_err:1;      
+            unsigned int cop_int_msk_disp1_sync:1;
+            unsigned int cop_int_msk_disp1_field:1;
+            unsigned int cop_int_msk_disp1_frame:1;
+            unsigned int cop_int_msk_disp2_frame:1;
+            unsigned int cop_int_msk_cap_finish:1;    
+            unsigned int cop_int_msk_main_f2f_finish:1;
+            unsigned int cop_int_msk_cap_change:1;
+            unsigned int reserved:22;
+        }bits;
+
+        unsigned int val;
+    }reg_glb_int_msk_cop;
+
+    union
+    {
+        struct
+        {
+            unsigned int host_int_sta_disp1_err:1;
+            unsigned int host_int_sta_disp2_err:1;
+            unsigned int host_int_sta_cap_err:1;     
+            unsigned int host_int_sta_disp1_sync:1;
+            unsigned int host_int_sta_disp1_field:1;
+            unsigned int host_int_sta_disp1_frame:1;
+            unsigned int host_int_sta_disp2_frame:1;
+            unsigned int host_int_sta_cap_finish:1;   
+            unsigned int host_int_sta_main_f2f_finish:1;
+            unsigned int host_int_sta_cap_change:1;
+            unsigned int reserved:22;
+        }bits;
+
+        unsigned int val;
+    }reg_glb_int_sta_host;
+
+    union
+    {
+        struct
+        {
+            unsigned int host_int_msk_disp1_err:1;
+            unsigned int host_int_msk_disp2_err:1;
+            unsigned int host_int_msk_cap_err:1;
+            unsigned int host_int_msk_disp1_sync:1;
+            unsigned int host_int_msk_disp1_field:1;
+            unsigned int host_int_msk_disp1_frame:1;
+            unsigned int host_int_msk_disp2_frame:1;
+            unsigned int host_int_msk_cap_finish:1;   
+            unsigned int host_int_msk_main_f2f_finish:1;
+            unsigned int host_int_msk_cap_change:1;
+            unsigned int reserved:22;
+        }bits;
+
+        unsigned int val;
+    }reg_glb_int_msk_host;
+
+    union
+    {
+       struct
+       {
+              unsigned int reserved:7;
+          unsigned int scale_coef3:25;
+       }bits;
+       unsigned int val;
+    }reg_glb_scale_coef3;
+
+    union
+    {
+       struct
+       {
+              unsigned int reserved:7;
+          unsigned int scale_coef4:25;
+       }bits;
+       unsigned int val;
+    }reg_glb_scale_coef4;
+
+    union
+    {
+       struct
+       {
+              unsigned int reserved:7;
+          unsigned int scale_coef6:25;
+       }bits;
+       unsigned int val;
+    }reg_glb_scale_coef6;
+
+    union
+    {
+       struct
+       {
+          unsigned int cpu_wq:1;
+              unsigned int reserved:31;
+       }bits;
+       unsigned int val;
+    }reg_glb_cpu_wq;
+
+    union
+    {
+       struct
+       {
+          unsigned int mips_rq:1;
+              unsigned int reserved:31;
+       }bits;
+       unsigned int val;
+    }reg_glb_mips_rq;
+
+    union
+    {
+       struct
+       {
+          unsigned int cur_status:2;
+              unsigned int reserved1:14;
+              unsigned int need_update:1;
+              unsigned int reserved2:15;
+       }bits;
+       unsigned int val;
+    }reg_glb_cur_status;
+
+    union
+    {
+       struct
+       {
+              unsigned int tg1_v_int_before_line_num:11;
+          unsigned int tg1_frame_int_sel:1;
+              unsigned int reserved1:4;
+              unsigned int tg2_v_int_before_line_num:11;
+          unsigned int tg2_frame_int_sel:1;
+              unsigned int reserved2:4;
+       }bits;
+       unsigned int val;
+    }reg_glb_tg_setting;
+}df_ctrl_reg;
+
+typedef struct _SR
+{
+
+    union
+    {
+        struct
+        {
+            unsigned int sr_src_top_field:1;
+            unsigned int reserved_1:3;
+            unsigned int sr_f2f_start:1;
+            unsigned int reserved_2:3;
+            unsigned int sr_f2f_3dr:1;
+            unsigned int reserved_3:3;
+            unsigned int sr_f2f_des_top_field:1;
+            unsigned int reserved_4:19;
+        }bits;
+        unsigned int val;
+    }reg_sr_ch_dyn_setting;
+    union
+    {
+        struct
+        {
+            unsigned int reserved_1:7;
+            unsigned int sr_f2f_store_frame_addr_y:25;
+        }bits;
+        unsigned int val;
+    }reg_sr_ch_dyn_store_frm_addr_y;
+
+    union
+    {
+        struct
+        {
+            unsigned int reserved_1:7;
+            unsigned int sr_f2f_store_frame_addr_c:25;
+        }bits;
+        unsigned int val;
+    }reg_sr_ch_dyn_store_frm_addr_c;
+
+    union
+    {
+        struct
+        {
+            unsigned int reserved_1:7;
+            unsigned int sr_frame_addr_cy:25;
+        }bits;
+        unsigned int val;
+    }reg_sr_ch_dyn_addr_cy;
+
+    union
+    {
+        struct
+        {
+            unsigned int reserved_1:7;
+            unsigned int sr_frame_addr_cy_3dr:25;
+        }bits;
+        unsigned int val;
+    }reg_sr_ch_dyn_addr_cy_3dr;
+
+    union
+    {
+        struct
+        {
+            unsigned int reserved_1:7;
+            unsigned int sr_frame_addr_cc:25;
+        }bits;
+        unsigned int val;
+    }reg_sr_ch_dyn_addr_cc;
+
+    union
+    {
+        struct
+        {
+            unsigned int reserved_1:7;
+            unsigned int sr_frame_addr_cc_3dr:25;
+        }bits;
+        unsigned int val;
+    }reg_sr_ch_dyn_addr_cc_3dr;
+
+    union
+    {
+        struct
+        {
+            unsigned int sr_y_src_line_pitch_128x:6;
+            unsigned int reserved_1:2;
+            unsigned int sr_c_src_line_pitch_128x:6;
+            unsigned int reserved_2:18;
+        }bits;
+        unsigned int val;
+    }reg_sr_ch_line_pitch;
+    union
+    {
+        struct
+        {
+            unsigned int sr_en:1;
+            unsigned int reserved_1:3;
+			unsigned int sr_rd_qa_en:1;
+            unsigned int reserved_2:3;
+            unsigned int sr_f2f_mode:1;
+			unsigned int sr_lb_init_step:6;
+			unsigned int reserved_3:1;
+            unsigned int sr_k:8;
+            unsigned int reserved_4:8;
+        }bits;
+        unsigned int val;
+    }reg_sr_ch_ctrl;
+
+    union
+    {
+        struct
+        {
+            unsigned int sr_src_is_i:1;
+            unsigned int reserved_1:7;
+            unsigned int sr_src_c_h_sample:1;
+            unsigned int reserved_2:3;
+            unsigned int sr_src_c_v_sample:1;
+            unsigned int reserved_3:3;
+            unsigned int sr_scr_v1_full:12;
+            unsigned int reserved_4:4;
+        }bits;
+        unsigned int val;
+    }reg_sr_ch_src_setting;
+
+    union
+    {
+        struct
+        {
+            unsigned int sr_src_h_start:11;
+            unsigned int reserved_1:5;
+            unsigned int sr_src_h_end:11;
+            unsigned int reserved_2:5;
+        }bits;
+        unsigned int val;
+    }reg_sr_ch_src_h_pos;
+
+    union
+    {
+        struct
+        {
+            unsigned int sr_src_v_start:12;
+            unsigned int reserved_1:4;
+            unsigned int sr_src_v_end:12;
+            unsigned int reserved_2:4;
+        }bits;
+        unsigned int val;
+    }reg_sr_ch_src_v_pos;
+
+    union
+    {
+        struct
+        {
+            unsigned int sr_des_is_i:1;
+            unsigned int reserved_1:3;
+            unsigned int sr_des_c_h_sample:1;
+            unsigned int reserved_2:3;
+            unsigned int sr_des_c_v_sample:1;
+            unsigned int reserved_3:23;
+        }bits;
+        unsigned int val;
+    }reg_sr_ch_des_setting;
+
+    union
+    {
+        struct
+        {
+            unsigned int sr_des_h_start:12;
+            unsigned int reserved_1:4;
+            unsigned int sr_des_h_end:12;
+            unsigned int reserved_2:4;
+        }bits;
+        unsigned int val;
+    }reg_sr_ch_des_h_pos;
+
+    union
+    {
+        struct
+        {
+            unsigned int sr_des_v_start:12;
+            unsigned int reserved_1:4;
+            unsigned int sr_des_v_end:12;
+            unsigned int reserved_2:4;
+            }bits;
+        unsigned int val;
+    }reg_sr_ch_des_v_pos;
+
+
+    union
+    {
+        struct
+        {
+            unsigned int sr_y_v_i_phase:6;
+            unsigned int reserved_1:2;
+            unsigned int sr_y_v_r0:17;
+            unsigned int reserved_2:7;
+        }bits;
+        unsigned int val;
+    }reg_sr_ch_scale_y_v_r;
+
+    union
+    {
+        struct
+        {
+            unsigned int sr_y_h_i_phase:6;
+            unsigned int reserved_1:2;
+            unsigned int sr_y_h_r0:17;
+            unsigned int reserved_2:7;
+        }bits;
+        unsigned int val;
+    }reg_sr_ch_scale_y_h_r;
+
+    union
+    {
+        struct
+        {
+            unsigned int sr_y_h_d0_abs:24;
+            unsigned int reserved_1:8;
+        }bits;
+        unsigned int val;
+    }reg_sr_ch_scale_y_h_d;
+
+    union
+    {
+        struct
+        {
+            unsigned int sr_y_h_k_abs:13;
+            unsigned int reserved_1:3;
+            unsigned int sr_y_h_k_sign:1;
+            unsigned int reserved_2:3;
+            unsigned int sr_y_h_k_radix:5;
+            unsigned int reserved_3:7;
+            }bits;
+        unsigned int val;
+    }reg_sr_ch_scale_y_h_k;
+
+    union
+    {
+        struct
+        {
+            unsigned int sr_y_h_n1:11;
+            unsigned int reserved_1:21;
+        }bits;
+        unsigned int val;
+    }reg_sr_ch_scale_y_h_n;
+
+    union
+    {
+        struct
+        {
+            unsigned int reserved_1:8;
+            unsigned int sr_c_v_r0:17;
+            unsigned int reserved_2:7;
+        }bits;
+        unsigned int val;
+    }reg_sr_ch_scale_c_v_r;
+
+    union
+    {
+        struct
+        {
+            unsigned int sr_c_h_i_phase:6;
+            unsigned int reserved_1:2;
+            unsigned int sr_c_h_r0:17;
+            unsigned int reserved_2:7;
+        }bits;
+        unsigned int val;
+    }reg_sr_ch_scale_c_h_r;
+
+    union
+    {
+        struct
+        {
+            unsigned int sr_c_h_d0_abs:24;
+            unsigned int reserved_1:8;
+        }bits;
+        unsigned int val;
+    }reg_sr_ch_scale_c_h_d;
+
+    union
+    {
+        struct
+        {
+            unsigned int sr_c_h_k_abs:13;
+            unsigned int reserved_1:3;
+            unsigned int sr_c_h_k_sign:1;
+            unsigned int reserved_2:3;
+            unsigned int sr_c_h_k_radix:5;
+            unsigned int reserved_3:7;
+        }bits;
+        unsigned int val;
+    }reg_sr_ch_scale_c_h_k;
+
+    union
+    {
+        struct
+        {
+            unsigned int sr_c_h_n1:11;
+            unsigned int reserved_1:21;
+        }bits;
+        unsigned int val;
+    }reg_sr_ch_scale_c_h_n;
+}SR;
+
+typedef struct _MAIN
+{
+
+    union
+    {
+        struct
+        {
+            unsigned int main_f2f_start:1;
+            unsigned int reserved_1:3;
+            unsigned int main_src_top_field:1;
+            unsigned int reserved_2:3;
+            unsigned int main_f2f_3dr:1;
+            unsigned int reserved_3:7;
+            unsigned int main_f2f_des_top_field:1;
+            unsigned int reserved_4:15;
+            }bits;
+        unsigned int val;
+    }reg_main_ch_dysetting;
+    union
+    {
+        struct
+        {
+            unsigned int reserved_1:7;
+            unsigned int main_f2f_store_frame_addr_y:25;
+        }bits;
+        unsigned int val;
+    }reg_main_ch_dyn_store_frm_addr_y;
+
+    union
+    {
+        struct
+        {
+            unsigned int reserved_1:7;
+            unsigned int main_f2f_store_frame_addr_c:25;
+        }bits;
+        unsigned int val;
+    }reg_main_ch_dyn_store_frm_addr_c;
+
+    union
+    {
+        struct
+        {
+            unsigned int reserved_1:7;
+            unsigned int main_frame_addr_fy:25;
+        }bits;
+        unsigned int val;
+    }reg_main_ch_dyn_frm_addr_fy;
+    union
+    {
+        struct
+        {
+            unsigned int reserved_1:7;
+            unsigned int main_frame_addr_cy:25;
+        }bits;
+        unsigned int val;
+    }reg_main_ch_dyn_frm_addr_cy;
+
+    union
+    {
+        struct
+        {
+            unsigned int reserved_1:7;
+            unsigned int main_frame_addr_by:25;
+        }bits;
+        unsigned int val;
+    }reg_main_ch_dyn_frm_addr_by;
+
+    union
+    {
+        struct
+        {
+            unsigned int reserved_1:7;
+            unsigned int main_frame_addr_bby:25;
+        }bits;
+        unsigned int val;
+    }reg_main_ch_dyn_frm_addr_bby;
+
+
+    union
+    {
+        struct
+        {
+            unsigned int reserved_1:7;
+            unsigned int main_frame_addr_fy_3dr:25;
+        }bits;
+        unsigned int val;
+    }reg_main_ch_dyn_frm_addr_fy_3dr;
+    union
+    {
+        struct
+        {
+            unsigned int reserved_1:7;
+            unsigned int main_frame_addr_cy_3dr:25;
+        }bits;
+        unsigned int val;
+    }reg_main_ch_dyn_frm_addr_cy_3dr;
+
+    union
+    {
+        struct
+        {
+            unsigned int reserved_1:7;
+            unsigned int main_frame_addr_by_3dr:25;
+        }bits;
+        unsigned int val;
+    }reg_main_ch_dyn_frm_addr_by_3dr;
+    union
+    {
+        struct
+        {
+            unsigned int reserved_1:7;
+            unsigned int main_frame_addr_bby_3dr:25;
+        }bits;
+        unsigned int val;
+    }reg_main_ch_dyn_frm_addr_bby_3dr;
+
+
+    union
+    {
+        struct
+        {
+            unsigned int reserved_1:7;
+            unsigned int main_frame_addr_fc:25;
+        }bits;
+        unsigned int val;
+    }reg_main_ch_dyn_frm_addr_fc;
+
+    union
+    {
+        struct
+        {
+            unsigned int reserved_1:7;
+            unsigned int main_frame_addr_cc:25;
+        }bits;
+        unsigned int val;
+    }reg_main_ch_dyn_frm_addr_cc;
+
+    union
+    {
+        struct
+        {
+            unsigned int reserved_1:7;
+            unsigned int main_frame_addr_bc:25;
+        }bits;
+        unsigned int val;
+    }reg_main_ch_dyn_frm_addr_bc;
+    union
+    {
+        struct
+        {
+            unsigned int reserved_1:7;
+            unsigned int main_frame_addr_bbc:25;
+        }bits;
+        unsigned int val;
+    }reg_main_ch_dyn_frm_addr_bbc;
+
+    union
+    {
+        struct
+        {
+            unsigned int reserved_1:7;
+            unsigned int main_frame_addr_fc_3dr:25;
+        }bits;
+        unsigned int val;
+    }reg_main_ch_dyn_frm_addr_fc_3dr;
+    union
+    {
+        struct
+        {
+            unsigned int reserved_1:7;
+            unsigned int main_frame_addr_cc_3dr:25;
+        }bits;
+        unsigned int val;
+    }reg_main_ch_dyn_frm_addr_cc_3dr;
+
+    union {
+        struct{
+            unsigned int reserved_1:7;
+            unsigned int main_frame_addr_bc_3dr:25;
+            }bits;
+        unsigned int val;
+    }reg_main_ch_dyn_frm_addr_bc_3dr;
+
+    union
+    {
+        struct
+        {
+            unsigned int reserved_1:7;
+            unsigned int main_frame_addr_bbc_3dr:25;
+        }bits;
+        unsigned int val;
+    }reg_main_ch_dyn_frm_addr_bbc_3dr;
+
+    union
+    {
+        struct
+        {
+            unsigned int main_f2f_store_line_pitch:6;
+            unsigned int reserved_1:26;
+        }bits;
+        unsigned int val;
+    }reg_main_f2f_store_pitch;
+
+
+
+    union
+    {
+        struct
+        {
+            unsigned int reserved_0:1;
+            unsigned int main_src_c_h_sample:1;
+            unsigned int main_src_c_v_sample:1;
+            unsigned int reserved_1:1;
+            unsigned int main_src_is_i:1;
+            unsigned int reserved_2:11;
+            unsigned int main_src_y_line_pitch_128x:6;
+            unsigned int reserved_3:2;
+            unsigned int main_src_c_line_pitch_128x:6;
+            unsigned int reserved_4:2;
+        }bits;
+        unsigned int val;
+    }reg_main_ch_src_setting;
+
+    union
+    {
+        struct
+        {
+            unsigned int main_src_h_start:11;
+            unsigned int reserved_1:5;
+            unsigned int main_src_h_end:11;
+            unsigned int reserved_2:5;
+        }bits;
+        unsigned int val;
+    }reg_main_ch_src_h_position;
+
+    union
+    {
+        struct
+        {
+            unsigned int main_src_v_start:12;
+            unsigned int reserved_1:4;
+            unsigned int main_src_v_end:12;
+            unsigned int reserved_2:4;
+        }bits;
+        unsigned int val;
+    }reg_main_ch_src_v_position;
+
+    union
+    {
+        struct
+        {
+            unsigned int main_des_is_i:1;
+            unsigned int main_des_c_h_sample:1;
+            unsigned int main_des_c_v_sample:1;
+            unsigned int reserved_1:29;
+        }bits;
+        unsigned int val;
+    }reg_main_ch_des_setting;
+
+    union
+    {
+        struct
+        {
+            unsigned int main_des_h_start:12;
+            unsigned int reserved_1:4;
+            unsigned int main_des_h_end:12;
+            unsigned int reserved_2:4;
+        }bits;
+        unsigned int val;
+    }reg_main_ch_des_h_position;
+
+    union
+    {
+        struct
+        {
+            unsigned int main_des_v_start:12;
+            unsigned int reserved_1:4;
+            unsigned int main_des_v_end:12;
+            unsigned int reserved_2:4;
+        }bits;
+        unsigned int val;
+    }reg_main_ch_des_v_position;
+
+
+    union {
+        struct
+        {
+            unsigned int main_y_v_r0:17;
+            unsigned int reserved_1:3;
+            unsigned int main_y_v_i_phase:6;
+            unsigned int reserved_2:6;
+        }bits;
+        unsigned int val;
+    }reg_main_ch_y_v_init_r0;
+
+    union
+    {
+        struct
+        {
+            unsigned int main_y_h_r0:17;
+            unsigned int reserved_1:3;
+            unsigned int main_y_h_i_phase:6;
+            unsigned int reserved_2:6;
+        }bits;
+        unsigned int val;
+    }reg_main_ch_y_h_init_r0;
+
+    union
+    {
+        struct
+        {
+            unsigned int main_y_h_d0_abs:24;
+            unsigned int reserved_1:8;
+        }bits;
+        unsigned int val;
+    }reg_main_ch_y_h_d0_abs;
+
+    union
+    {
+        struct
+        {
+            unsigned int main_y_h_k_abs:13;
+            unsigned int reserved_1:3;
+            unsigned int main_y_h_k_sign:1;
+            unsigned int reserved_2:3;
+            unsigned int main_y_h_k_radix:5;
+            unsigned int reserved_3:7;
+        }bits;
+        unsigned int val;
+    }reg_main_ch_y_h_k;
+
+    union
+    {
+        struct
+        {
+            unsigned int main_y_h_n1:11;
+            unsigned int reserved_1:21;
+        }bits;
+        unsigned int val;
+    }reg_main_ch_y_h_n1;
+
+
+    union
+    {
+        struct
+        {
+            unsigned int main_c_v_r0:17;
+            unsigned int reserved_1:3;
+            unsigned int reserved_2:12;
+        }bits;
+        unsigned int val;
+    }reg_main_ch_c_v_init_r0;
+
+    union
+    {
+        struct
+        {
+            unsigned int main_c_h_r0:17;
+            unsigned int reserved_1:3;
+            unsigned int main_c_h_i_phase:6;
+            unsigned int reserved_2:6;
+        }bits;
+        unsigned int val;
+    }reg_main_ch_c_h_init_r0;
+
+    union
+    {
+        struct
+        {
+            unsigned int main_c_h_d0_abs:24;
+            unsigned int reserved_1:8;
+        }bits;
+        unsigned int val;
+    }reg_main_ch_c_h_d0_abs;
+
+    union
+    {
+        struct
+        {
+            unsigned int main_c_h_k_abs:13;
+            unsigned int reserved_1:3;
+            unsigned int main_c_h_k_sign:1;
+            unsigned int reserved_2:3;
+            unsigned int main_c_h_k_radix:5;
+            unsigned int reserved_3:7;
+        }bits;
+        unsigned int val;
+    }reg_main_ch_c_h_k;
+
+    union
+    {
+        struct
+        {
+            unsigned int main_c_h_n1:11;
+            unsigned int reserved_1:21;
+        }bits;
+        unsigned int val;
+    }reg_main_ch_c_h_n1;
+    union
+    {
+        struct
+        {
+            unsigned int main_cof_yv6_group:4;
+            unsigned int main_cof_yv3_group:4;
+            unsigned int main_cof_yh6_group:4;
+            unsigned int main_cof_ch6_group:4;
+            unsigned int reserved_1:16;
+        }bits;
+        unsigned int val;
+    }reg_main_ch_cof_ctrl;
+
+    union
+    {
+        struct
+        {
+            unsigned int main_ups_en:1;
+            unsigned int reserved_1:3;
+            unsigned int main_ups_pv:1;
+            unsigned int reserved_2:3;
+            unsigned int main_ups_th_up:8;
+            unsigned int main_ups_th_dn:8;
+            unsigned int main_ups_th_factor:8;
+        }bits;
+        unsigned int val;
+    }reg_main_ups_setting;
+    union
+    {
+        struct
+        {
+            unsigned int main_y_en:1;
+            unsigned int main_c_en:1;
+            unsigned int main_src_i_bf_invert:1;
+            unsigned int reserved_1:1;
+            unsigned int main_rd_qa_en:1;
+            unsigned int reserved_2:3;
+            unsigned int main_f2f_mode:1;
+			unsigned int main_lb_init_step:6;
+			unsigned int reserved_3:1;
+            unsigned int main_scr_v1_full:12;
+            unsigned int reserved_4:4;
+        }bits;
+        unsigned int val;
+    }reg_main_ch_ctrl;
+    union
+    {
+        struct
+        {
+            unsigned int main_y_tnr_en:1;
+            unsigned int reserved_1:3;
+            unsigned int main_y_tnr_frame:1;
+            unsigned int reserved_2:3;
+            unsigned int main_y_tnr_gate:6;
+            unsigned int reserved_3:2;
+            unsigned int main_y_tnr_div:2;
+            unsigned int reserved_4:14;
+        }bits;
+        unsigned int val;
+    }reg_main_ch_y_tnr_setting;
+
+    union
+    {
+        struct
+        {
+            unsigned int main_y_madi_en:1;
+            unsigned int reserved_1:3;
+            unsigned int main_y_madi_gate:3;
+            unsigned int reserved_2:1;
+            unsigned int main_y_madi_force_3d:1;
+            unsigned int reserved_3:23;
+        }bits;
+        unsigned int val;
+    }reg_main_ch_y_madi_setting;
+
+    union
+    {
+        struct
+        {
+            unsigned int main_y_dir_en:1;
+            unsigned int reserved_1:3;
+            unsigned int main_y_dir_min0:5;
+            unsigned int reserved_2:3;
+            unsigned int main_y_dir_min1:5;
+            unsigned int reserved_3:3;
+            unsigned int main_y_dir_k0:4;
+            unsigned int main_y_dir_k1:4;
+            unsigned int main_y_dir_max:4;
+        }bits;
+        unsigned int val;
+    }reg_main_ch_y_dir_setting;
+    union
+    {
+        struct
+        {
+            unsigned int main_c_tnr_en:1;
+            unsigned int reserved_1:7;
+            unsigned int main_c_tnr_gate:6;
+            unsigned int reserved_3:2;
+            unsigned int main_c_tnr_div:2;
+            unsigned int reserved_4:14;
+        }bits;
+        unsigned int val;
+    }reg_main_ch_c_tnr_setting;
+
+    union
+    {
+        struct
+        {
+            unsigned int main_c_madi_en:1;
+            unsigned int reserved_1:3;
+            unsigned int main_c_madi_gate:3;
+            unsigned int reserved_2:25;
+        }bits;
+        unsigned int val;
+    }reg_main_ch_c_madi_setting;
+
+    union
+    {
+        struct
+        {
+            unsigned int main_c_dir_en:1;
+            unsigned int reserved_1:3;
+            unsigned int main_c_dir_min0:5;
+            unsigned int reserved_2:3;
+            unsigned int main_c_dir_min1:5;
+            unsigned int reserved_3:3;
+            unsigned int main_c_dir_k0:4;
+            unsigned int main_c_dir_k1:4;
+            unsigned int main_c_dir_max:4;
+        }bits;
+        unsigned int val;
+    }reg_main_ch_c_dir_setting;
+
+    union
+    {
+        struct
+        {
+            unsigned int blend1_bg_y:10;
+            unsigned int blend1_bg_u:10;
+            unsigned int blend1_bg_v:10;
+            unsigned int reserved_1:2;
+        }bits;
+        unsigned int val;
+    }reg_main_b1_back_ground;
+
+    union
+    {
+        struct
+        {
+            unsigned int blend1_result_x_start:12;
+            unsigned int reserved_1:4;
+            unsigned int blend1_result_x_end:12;
+            unsigned int reserved_2:4;
+        }bits;
+        unsigned int val;
+    }reg_main_b1_des_position_x;
+
+    union
+    {
+        struct
+        {
+            unsigned int blend1_result_y_start:12;
+            unsigned int reserved_1:4;
+            unsigned int blend1_result_y_end:12;
+            unsigned int reserved_2:4;
+        }bits;
+        unsigned int val;
+    }reg_main_b1_des_position_y;
+    union
+    {
+        struct
+        {
+            unsigned int main_bg_en:1;
+            unsigned int reserved_1:31;
+        }bits;
+        unsigned int val;
+    }reg_main_b1_ctrl;
+    union
+    {
+        struct
+        {
+            unsigned int line_cnt_y_f2f_wr:12;
+            unsigned int reserved_1:4;
+            unsigned int main_wr_f2f_finish:1;
+            unsigned int reserved_2:15;
+        }bits;
+        unsigned int val;
+    }reg_main_sta_vpp_num;
+}MAIN;
+
+typedef struct _F2F_RD
+{
+    union
+    {
+        struct
+        {
+            unsigned int reserved_1:7;
+            unsigned int f2f_rd_frame_addr_y:25;
+        }bits;
+        unsigned int val;
+    }reg_f2f_rd_yf_addr;
+
+    union
+    {
+        struct
+        {
+            unsigned int reserved_1:7;
+            unsigned int f2f_rd_frame_addr_c:25;
+        }bits;
+        unsigned int val;
+    }reg_f2f_rd_cf_addr;
+    union
+    {
+        struct
+        {
+            unsigned int f2f_rd_video_en:1;
+            unsigned int reserved_1:15;
+            unsigned int f2f_rd_line_pitch:6;
+            unsigned int reserved_2:10;
+        }bits;
+        unsigned int val;
+    }reg_f2f_rd_ctrl;
+    union
+    {
+        struct
+        {
+            unsigned int f2f_rd_src_x_start:12;
+            unsigned int reserved_1:4;
+            unsigned int f2f_rd_src_x_end:12;
+            unsigned int reserved_2:4;
+        }bits;
+        unsigned int val;
+    }reg_f2f_rd_src_x_crop;
+
+    union
+    {
+        struct
+        {
+            unsigned int f2f_rd_src_y_start:12;
+            unsigned int reserved_1:4;
+            unsigned int f2f_rd_src_y_end:12;
+            unsigned int reserved_2:4;
+        }bits;
+        unsigned int val;
+    }reg_f2f_rd_src_y_crop;
+
+    union
+    {
+        struct
+        {
+            unsigned int f2f_rd_disp_x_start:12;
+            unsigned int reserved_1:4;
+            unsigned int f2f_rd_disp_x_end:12;
+            unsigned int reserved_2:4;
+        }bits;
+        unsigned int val;
+    }reg_f2f_rd_x_position;
+
+    union
+    {
+        struct
+        {
+            unsigned int f2f_rd_disp_y_start:12;
+            unsigned int reserved_1:4;
+            unsigned int f2f_rd_disp_y_end:12;
+            unsigned int reserved_2:4;
+        }bits;
+        unsigned int val;
+    }reg_f2f_rd_y_position;
+
+    union
+    {
+        struct
+        {
+            unsigned int f2f_rd_disp_num:32;
+        }bits;
+        unsigned int val;
+    }reg_f2f_rd_disp_num;
+
+}F2F_RD;
+
+typedef struct _HD2SD_RD
+{
+    union
+    {
+        struct
+        {
+            unsigned int reserved_1:7;
+            unsigned int hd2sd_rd_y_128_addr_frame:25;
+        }bits;
+        unsigned int val;
+    }reg_hd2sd_rd_yf_addr;
+
+    union
+    {
+        struct
+        {
+            unsigned int reserved_1:7;
+            unsigned int hd2sd_rd_c_128_addr_frame:25;
+        }bits;
+        unsigned int val;
+    }reg_hd2sd_rd_cf_addr;
+    union
+    {
+        struct
+        {
+            unsigned int hd2sd_rd_video_en:1;
+            unsigned int reserved_1:15;
+            unsigned int hd2sd_rd_line_pitch:6;
+            unsigned int reserved_2:10;
+        }bits;
+        unsigned int val;
+    }reg_hd2sd_rd_ctrl;
+    union
+    {
+        struct
+        {
+            unsigned int hd2sd_rd_src_x_start:12;
+            unsigned int reserved_1:4;
+            unsigned int hd2sd_rd_src_x_end:12;
+            unsigned int reserved_2:4;
+        }bits;
+        unsigned int val;
+    }reg_hd2sd_rd_src_x_crop;
+
+    union
+    {
+        struct
+        {
+            unsigned int hd2sd_rd_src_y_start:12;
+            unsigned int reserved_1:4;
+            unsigned int hd2sd_rd_src_y_end:12;
+            unsigned int reserved_2:4;
+        }bits;
+        unsigned int val;
+    }reg_hd2sd_rd_src_y_crop;
+
+    union
+    {
+        struct
+        {
+            unsigned int hd2sd_rd_video_x_start:12;
+            unsigned int reserved_1:4;
+            unsigned int hd2sd_rd_video_x_end:12;
+            unsigned int reserved_2:4;
+        }bits;
+        unsigned int val;
+    }reg_hd2sd_rd_x_position;
+
+    union
+    {
+        struct
+        {
+            unsigned int hd2sd_rd_video_y_start:12;
+            unsigned int reserved_1:4;
+            unsigned int hd2sd_rd_video_y_end:12;
+            unsigned int reserved_2:4;
+        }bits;
+        unsigned int val;
+    }reg_hd2sd_rd_y_position;
+
+    union
+    {
+        struct
+        {
+            unsigned int hd2sd_rd_disp_num:32;
+        }bits;
+        unsigned int val;
+    }reg_hd2sd_rd_disp_num;
+}HD2SD_RD;
+
+typedef struct _DMA
+{
+        union
+        {
+            struct
+            {
+                unsigned int reserved1:7;
+                unsigned int dma_rd_yf_addr:25;
+         }bits;
+            unsigned int val;
+        }reg_dma_rd_yf_addr;
+        union
+        {
+            struct
+            {
+                unsigned int reserved1:7;
+                unsigned int dma_rd_cf_addr:25;
+         }bits;
+            unsigned int val;
+        }reg_dma_rd_cf_addr;
+        union
+        {
+            struct
+            {
+                unsigned int reserved1:7;
+                unsigned int dma_wr_yf_addr:25;
+         }bits;
+            unsigned int val;
+        }reg_dma_wr_yf_addr;
+        union
+        {
+            struct
+            {
+                unsigned int reserved1:7;
+                unsigned int dma_wr_cf_addr:25;
+         }bits;
+            unsigned int val;
+        }reg_dma_wr_cf_addr;
+        union
+        {
+            struct
+            {
+                unsigned int dma_en:1;
+                unsigned int reserved1:3;
+                unsigned int dma_src_c_v_sample:1;
+                unsigned int reserved2:3;
+                unsigned int dma_start:1;
+                unsigned int reserved3:7;
+                unsigned int dma_rd_line_pitch:6;
+                unsigned int reserved4:2;
+                unsigned int dma_wr_line_pitch:6;
+                unsigned int reserved5:2;
+         }bits;
+            unsigned int val;
+        }reg_dma_ctrl;
+        union
+        {
+            struct
+            {
+                unsigned int dma_src_x_start:12;
+                unsigned int reserved1:4;
+                unsigned int dma_src_x_end:12;
+                unsigned int reserved2:4;
+         }bits;
+            unsigned int val;
+        }reg_dma_src_x_crop;
+        union
+        {
+            struct
+            {
+                unsigned int dma_src_y_start:12;
+                unsigned int reserved1:4;
+                unsigned int dma_src_y_end:12;
+                unsigned int reserved2:4;
+         }bits;
+            unsigned int val;
+        }reg_dma_src_y_crop;
+        union
+        {
+            struct
+            {
+                unsigned int dma_des_x_start:12;
+                unsigned int reserved1:4;
+                unsigned int dma_des_x_end:12;
+                unsigned int reserved2:4;
+         }bits;
+            unsigned int val;
+        }reg_dma_des_x_position;
+        union
+        {
+            struct
+            {
+                unsigned int dma_des_y_start:12;
+                unsigned int reserved1:4;
+                unsigned int dma_des_y_end:12;
+                unsigned int reserved2:4;
+         }bits;
+            unsigned int val;
+        }reg_dma_des_y_position;
+}DMA;
+
+typedef struct _CAP
+{
+
+    union
+    {
+        struct
+        {
+			unsigned int cap_en:1;
+			unsigned int cap_c_v_sample:1;
+			unsigned int reserved_1:2;
+			unsigned int cap_des_is_i:1;
+			unsigned int reserved_2:3;
+			unsigned int cap_cap_left:1;
+			unsigned int reserved_3:3;
+			unsigned int hd2sd_3frame_mode:1;
+            unsigned int reserved_4:1;
+            unsigned int cap_frame_get:1;
+			unsigned int hd2sd_frame_release:1;
+			unsigned int cap_line_pitch:6;
+			unsigned int reserved_5:10;
+        }bits;
+        unsigned int val;
+	}reg_cap_ctrl;
+	union
+	{
+		struct
+		{
+			unsigned int cap_src_ext:1;
+			unsigned int cap_ext_fs_sel:1;
+			unsigned int cap_ext_fs_pol:1;
+			unsigned int cap_ext_vs_pol:1;
+			unsigned int cap_ext_hs_pol:1;
+			unsigned int cap_ext_emb_en:1;
+			unsigned int cap_ext_2lane:1;
+			unsigned int cap_ext_10bpc:1;
+			unsigned int cap_ext_csc_en:1;
+			unsigned int cap_scr_is_i:1;
+			unsigned int cap_scr_c_h_sample:1;
+			unsigned int reserved_1:21;
+		}bits;
+		unsigned int val;
+	}reg_cap_scr_setting;
+	union
+	{
+		struct
+		{
+			unsigned int cap_scr_h_start:12;
+			unsigned int reserved_1:4;
+			unsigned int cap_scr_h_end:12;
+			unsigned int reserved_2:4;
+		}bits;
+		unsigned int val;
+	}reg_cap_scr_h_position;
+	union
+	{
+		struct
+		{
+			unsigned int cap_scr_v_start:12;
+			unsigned int reserved_1:4;
+			unsigned int cap_scr_v1_full:12;
+			unsigned int reserved_2:4;
+		}bits;
+		unsigned int val;
+	}reg_cap_scr_v_position;
+
+    union
+    {
+        struct
+        {
+			unsigned int cap_des_h_start:12;
+            unsigned int reserved_1:4;
+			unsigned int cap_des_h_end:12;
+            unsigned int reserved_2:4;
+        }bits;
+        unsigned int val;
+	}reg_cap_des_h_position;
+	union
+	{
+		struct
+		{
+			unsigned int cap_des_v_start:12;
+			unsigned int reserved_1:4;
+			unsigned int cap_des_v_end:12;
+			unsigned int reserved_2:4;
+		}bits;
+		unsigned int val;
+	}reg_cap_des_v_position;
+
+    union
+    {
+        struct
+        {
+			unsigned int cap_sca_y_v_r0:17;
+			unsigned int reserved_1:15;
+		}bits;
+		unsigned int val;
+	}reg_cap_yv_ratio;
+
+    union
+    {
+        struct
+        {
+			unsigned int cap_sca_y_h_r0:17;
+			unsigned int reserved_1:15;
+		}bits;
+		unsigned int val;
+	}reg_cap_yh_ratio;
+
+    union
+    {
+        struct
+        {
+			unsigned int cap_sca_c_v_r0:17;
+			unsigned int reserved_1:15;
+		}bits;
+		unsigned int val;
+	}reg_cap_cv_ratio;
+
+    union
+    {
+        struct
+        {
+			unsigned int cap_sca_c_h_r0:17;
+            unsigned int reserved_1:15;
+        }bits;
+        unsigned int val;
+	}reg_cap_ch_ratio;
+
+    union
+    {
+        struct
+        {
+			unsigned int cap_sca_y_d0_abs:24;
+			unsigned int reserved_1:8;
+        }bits;
+        unsigned int val;
+	}reg_cap_y_noline_d;
+
+    union
+    {
+        struct
+        {
+			unsigned int cap_sca_c_d0_abs:24;
+			unsigned int reserved_1:8;
+		}bits;
+		unsigned int val;
+	}reg_cap_c_noline_d;
+    union
+    {
+        struct
+		{
+			unsigned int cap_sca_y_h_k_abs:13;
+			unsigned int reserved_1:2;
+			unsigned int cap_sca_y_h_k_sign:1;
+			unsigned int cap_sca_y_h_k_radix:5;
+			unsigned int cap_sca_y_h_n1:11;
+		}bits;
+		unsigned int val;
+	}reg_cap_y_noline_k;
+
+    union
+    {
+        struct
+        {
+			unsigned int cap_sca_c_h_k_abs:13;
+			unsigned int reserved_1:2;
+			unsigned int cap_sca_c_h_k_sign:1;
+			unsigned int cap_sca_c_h_k_radix:5;
+			unsigned int cap_sca_c_h_n1:11;
+        }bits;
+        unsigned int val;
+	}reg_cap_c_noline_k;
+	union
+	{
+		struct
+		{
+			unsigned int cap_iphase_h_y:6;
+			unsigned int reserved_1:10;
+			unsigned int cap_iphase_h_c:6;
+			unsigned int reserved_2:10;
+		}bits;
+		unsigned int val;
+	}reg_cap_hor_phase;
+
+	union
+	{
+		struct
+		{
+			unsigned int cap_iphase_v_y:6;
+			unsigned int reserved_1:26;
+		}bits;
+		unsigned int val;
+	}reg_cap_ver_phase;
+
+	union
+	{
+		struct
+		{
+			unsigned int reserved_1:7;
+			unsigned int cap_y_128_addr_frame0:25;
+		}bits;
+		unsigned int val;
+	}reg_cap_yt_addr0;
+
+	union
+	{
+		struct
+		{
+			unsigned int reserved_1:7;
+			unsigned int cap_c_128_addr_frame0:25;
+		}bits;
+		unsigned int val;
+	}reg_cap_ct_addr0;
+	union
+	{
+		struct
+		{
+			unsigned int reserved_1:7;
+			unsigned int cap_y_128_addr_frame1:25;
+		}bits;
+		unsigned int val;
+	}reg_cap_yt_addr1;
+
+	union
+	{
+		struct
+		{
+			unsigned int reserved_1:7;
+			unsigned int cap_c_128_addr_frame1:25;
+		}bits;
+		unsigned int val;
+	}reg_cap_ct_addr1;
+	union
+	{
+		struct
+		{
+			unsigned int reserved_1:7;
+			unsigned int cap_y_128_addr_frame2:25;
+		}bits;
+		unsigned int val;
+	}reg_cap_yt_addr2;
+
+	union
+	{
+		struct
+		{
+			unsigned int reserved_1:7;
+			unsigned int cap_c_128_addr_frame2:25;
+		}bits;
+		unsigned int val;
+	}reg_cap_ct_addr2;
+	union
+	{
+		struct
+		{
+			unsigned int reserved_1:7;
+			unsigned int cap_y_128_addr_frame3:25;
+		}bits;
+		unsigned int val;
+	}reg_cap_yt_addr3;
+
+	union
+	{
+		struct
+		{
+			unsigned int reserved_1:7;
+			unsigned int cap_c_128_addr_frame3:25;
+		}bits;
+		unsigned int val;
+	}reg_cap_ct_addr3;
+	union
+	{
+		struct
+		{
+			unsigned int reserved_1:7;
+			unsigned int cap_y_128_addr_frame4:25;
+		}bits;
+		unsigned int val;
+	}reg_cap_yt_addr4;
+
+	union
+	{
+		struct
+		{
+			unsigned int reserved_1:7;
+			unsigned int cap_c_128_addr_frame4:25;
+		}bits;
+		unsigned int val;
+	}reg_cap_ct_addr4;
+	union
+	{
+		struct
+		{
+			unsigned int cap_cof_yv4_group:4;
+			unsigned int cap_cof_cv4_group:4;
+			unsigned int cap_cof_yh6_group:4;
+			unsigned int cap_cof_ch6_group:4;
+			unsigned int cap_line_finish_cnt:12;
+			unsigned int reserved_2:4;
+        }bits;
+        unsigned int val;
+	}reg_cap_coeff_no;
+
+	union
+	{
+		struct
+		{
+			unsigned int cap_idx:3;
+			unsigned int reserved:29;
+		}bits;
+		unsigned int val;
+	}reg_cap_idx;
+
+	union
+	{
+		struct
+		{
+			unsigned int cap_pts:32;
+		}bits;
+		unsigned int val;
+	}reg_cap_pts;
+
+	union
+	{
+		struct
+		{
+			unsigned int cap_stc:32;
+		}bits;
+		unsigned int val;
+	}reg_cap_stc_tg1;
+	union
+	{
+		struct
+		{
+			unsigned int cap_line_cnt:12;
+			unsigned int reserved_1:20;
+		}bits;
+		unsigned int val;
+	}reg_cap_line_cnt;
+
+    union
+    {
+        struct
+        {
+            unsigned int cap_status:32;
+        }bits;
+        unsigned int val;
+    }reg_cap_status;
+    union
+    {
+        struct
+        {
+            unsigned int cap_h_resolution:12;
+            unsigned int reserved_1:4;
+            unsigned int cap_v_resolution:12;
+            unsigned int reserved_2:3;
+            unsigned int cap_format_change:1;
+        }bits;
+        unsigned int val;
+    }reg_cap_format;
+
+}CAP;
+
+typedef struct _COMP
+{
+    union{
+        struct{
+            unsigned int blending2_bg_y:10;
+            unsigned int blending2_bg_u:10;
+            unsigned int blending2_bg_v:10;
+            unsigned int reserved_1:2;
+        }bits;
+        unsigned int val;
+    }reg_comp_b2_back_ground;
+
+    union{
+        struct{
+            unsigned int blending2_video1_z_order:2;
+            unsigned int reserved_1:2;
+            unsigned int blending2_video2_z_order:2;
+            unsigned int reserved_2:2;
+            unsigned int blending2_gfx1_z_order:2;
+            unsigned int reserved_3:2;
+            unsigned int blending2_gfx2_z_order:2;
+            unsigned int reserved_4:18;
+        }bits;
+        unsigned int val;
+    }reg_comp_b2_z_order;
+
+    union{
+        struct{
+            unsigned int blending2_default_alpha1:10;
+            unsigned int reserved_1:6;
+            unsigned int blending2_default_alpha2:10;
+            unsigned int reserved_2:6;
+        }bits;
+        unsigned int val;
+    }reg_comp_b2_default_alpha;
+    union{
+        struct{
+            unsigned int blending3_bg_y:10;
+            unsigned int blending3_bg_u:10;
+            unsigned int blending3_bg_v:10;
+            unsigned int reserved_1:2;
+        }bits;
+        unsigned int val;
+    }reg_comp_b3_back_ground;
+
+    union{
+        struct{
+            unsigned int blending3_video1_z_order:2;
+            unsigned int reserved_1:2;
+            unsigned int reserved_2:4;
+            unsigned int blending3_gfx1_z_order:2;
+            unsigned int reserved_3:4;
+            unsigned int reserved_4:18;
+        }bits;
+        unsigned int val;
+    }reg_comp_b3_z_order;
+
+    union{
+        struct{
+            unsigned int blending3_default_alpha1:10;
+            unsigned int reserved_1:6;
+            unsigned int reserved_2:16;
+        }bits;
+        unsigned int val;
+    }reg_comp_b3_default_alpha;
+
+
+    union{
+        struct{
+            unsigned int enh_y_sharp_en:1;
+            unsigned int enh_y_median_en:1;
+            unsigned int enh_y_coring_soft:1;
+            unsigned int reserved_1:1;
+            unsigned int enh_y_peaking_shrink:3;
+            unsigned int reserved_2:1;
+            unsigned int enh_y_coring:6;
+            unsigned int reserved_3:2;
+            unsigned int enh_y_bpw:8;
+            unsigned int enh_y_hpw:8;
+        }bits;
+        unsigned int val;
+    }reg_comp_sharp_y;
+
+    union{
+        struct{
+            unsigned int enh_c_sharp_en:1;
+            unsigned int enh_c_median_en:1;
+            unsigned int enh_c_coring_soft:1;
+            unsigned int reserved_1:1;
+            unsigned int enh_c_peaking_shrink:3;
+            unsigned int reserved_2:1;
+            unsigned int enh_c_coring:6;
+            unsigned int reserved_3:2;
+            unsigned int enh_c_bpw:8;
+            unsigned int enh_c_hpw:8;
+        }bits;
+        unsigned int val;
+    }reg_comp_sharp_c;
+
+    union{
+        struct{
+            unsigned int enh_bright:8;
+            unsigned int enh_contrast:6;
+            unsigned int reserved_1:2;
+            unsigned int enh_saturation:8;
+            unsigned int reserved_2:8;
+        }bits;
+        unsigned int val;
+    }reg_comp_color_adjust;
+}df_compositor_reg;
+
+typedef struct _TG
+{
+    union
+    {
+        struct
+        {
+            unsigned int tg_en:1;
+            unsigned int reserved_1:1;
+            unsigned int tg_is_hd:1;
+            unsigned int reserved_2:2;
+            unsigned int tg_is_interlaced:1;
+            unsigned int reserved_3:1;
+            unsigned int tg_is_pal:1;
+            unsigned int reserved_3_1:3;
+            unsigned int tg_dither_mode:1;
+            unsigned int tg_hsync_pol:1;
+            unsigned int tg_vsync_pol:1;
+            unsigned int tg_dither_ena:1;
+            unsigned int reserved_4:1;
+            unsigned int tg_3d_act_space:8;
+            unsigned int tg_3d_en:1;
+            unsigned int reserved_5:7;
+        }bits;
+        unsigned int val;
+    }reg_tg_ctrl;
+
+    union
+    {
+        struct
+        {
+            unsigned int tg_htotal:13;
+            unsigned int reserved_1:3;
+            unsigned int tg_hactive_width:12;
+            unsigned int reserved_2:4;
+        }bits;
+        unsigned int val;
+    }reg_tg_x_size;
+
+    union
+    {
+        struct
+        {
+            unsigned int tg_vtotal:13;
+            unsigned int reserved_1:3;
+            unsigned int tg_vactive_height:12;
+            unsigned int reserved_2:4;
+        }bits;
+        unsigned int val;
+    }reg_tg_y_size;
+
+    union
+    {
+        struct
+        {
+            unsigned int tg_hsync_front_porch:10;
+            unsigned int tg_hsync_width:10;
+            unsigned int tg_hsync_back_porch:10;
+            unsigned int reserved_1:2;
+        }bits;
+        unsigned int val;
+    }reg_tg_hsync;
+
+    union
+    {
+        struct
+        {
+            unsigned int tg_vsync_front_porch:8;
+            unsigned int tg_vsync_width:8;
+            unsigned int tg_vsync_back_porch:8;
+            unsigned int reserved_1:8;
+        }bits;
+        unsigned int val;
+    }reg_tg_vsync;
+
+    union
+    {
+        struct
+        {
+            unsigned int tg_vga_black_level:10;
+            unsigned int reserved_1:6;
+            unsigned int tg_vga_white_level:10;
+            unsigned int reserved_2:6;
+        }bits;
+        unsigned int val;
+    }reg_tg_vga_level;
+
+    union
+    {
+        struct
+        {
+            unsigned int tg_v_start_line_num: 6;
+            unsigned int reserved_1:10;
+            unsigned int reserved_2:16;
+        }bits;
+        unsigned int val;
+    }reg_tg_sta_line;
+
+    union
+    {
+        struct
+        {
+            unsigned int disp_width: 12;
+            unsigned int reserved_1:4;
+            unsigned int disp_height: 12;
+            unsigned int reserved_2:4;
+        }bits;
+        unsigned int val;
+    }reg_tg_sta_disp_size;
+
+    union
+    {
+        struct
+        {
+            unsigned int disp_scan_line_cnt: 13;
+            unsigned int reserved_1:3;
+            unsigned int disp_scan_line_active_line: 1;
+            unsigned int reserved_2:3;
+            unsigned int disp_bottom_flag: 1;
+            unsigned int reserved_3:3;
+            unsigned int disp_vsync: 1;
+            unsigned int reserved_4:7;
+        }bits;
+        unsigned int val;
+    }reg_tg_sta_disp_line;
+}df_outif_reg;
+
+typedef struct _UI
+{
+        union
+        {
+            struct
+            {
+                unsigned int gfx_ui_ena:1;
+                unsigned int gfx_ui_format:3;
+                unsigned int gfx_ui_endian:2;
+                unsigned int gfx_ui_opaque:1;
+                unsigned int gfx_ui_color_keying_en:1;
+                unsigned int gfx_ui_ena_premul:1;
+                unsigned int gfx_ui_af_sc_dis:1;
+                unsigned int gfx_ui_antiflicker_en_a:1;
+                unsigned int gfx_ui_antiflicker_en_c:1;
+                unsigned int gfx_ui_ena_demul:1;
+                unsigned int gfx_ui_yuv_conv_ena:1;
+                unsigned int reserved1:2;
+                unsigned int gfx_ui_bw_limit:8;
+                unsigned int ui_tg1_en:1;
+                unsigned int reserved2:7;
+            }bits;
+            unsigned int val;
+        }reg_gfx_ui_ctrl;
+        union
+        {
+            struct
+            {
+                unsigned int gfx_ui_src_width:16;
+                unsigned int gfx_ui_src_height:16;
+            }bits;
+            unsigned int val;
+        }reg_gfx_ui_size;
+        union
+        {
+            struct
+            {
+                unsigned int gfx_ui_default_alpha:8;
+                unsigned int reserved1:2;
+                unsigned int gfx_ui_argb1555_a0:8;
+                unsigned int reserved2:2;
+                unsigned int gfx_ui_argb1555_a1:8;
+                unsigned int reserved3:4;
+            }bits;
+            unsigned int val;
+        }reg_gfx_ui_alpha_ctrl;
+        union
+        {
+            struct
+            {
+                unsigned int gfx_ui_r_min:8;
+                unsigned int gfx_ui_r_max:8;
+                unsigned int reserved1:16;
+            }bits;
+            unsigned int val;
+        }reg_gfx_ui_key_red;
+        union
+        {
+            struct
+            {
+                unsigned int gfx_ui_b_min:8;
+                unsigned int gfx_ui_b_max:8;
+                unsigned int reserved1:16;
+            }bits;
+            unsigned int val;
+        }reg_gfx_ui_key_blue;
+        union
+        {
+            struct
+            {
+                unsigned int gfx_ui_g_min:8;
+                unsigned int gfx_ui_g_max:8;
+                unsigned int reserved1:16;
+            }bits;
+            unsigned int val;
+        }reg_gfx_ui_key_green;
+        union
+        {
+            struct
+            {
+                unsigned int gfx_ui_buf_start:32;
+            }bits;
+            unsigned int val;
+        }reg_gfx_ui_buf_start;
+        union
+        {
+            struct
+            {
+                unsigned int gfx_ui_buf_start_3d:32;
+            }bits;
+            unsigned int val;
+        }reg_gfx_ui_buf_start_3d;
+        union
+        {
+            struct
+            {
+                unsigned int gfx_ui_line_pitch:32;
+            }bits;
+            unsigned int val;
+        }reg_gfx_ui_line_pitch;
+        union
+        {
+            struct
+            {
+                unsigned int gfx_ui_dst_x_start:16;
+                unsigned int gfx_ui_dst_x_end:16;
+            }bits;
+            unsigned int val;
+        }reg_gfx_ui_x_position;
+        union
+        {
+            struct
+            {
+                unsigned int gfx_ui_dst_y_start:16;
+                unsigned int gfx_ui_dst_y_end:16;
+            }bits;
+            unsigned int val;
+        }reg_gfx_ui_y_position;
+        union
+        {
+            struct
+            {
+                unsigned int gfx_ui_a8_r:8;
+                unsigned int gfx_ui_a8_g:8;
+                unsigned int gfx_ui_a8_b:8;
+                unsigned int reserved1:8;
+            }bits;
+            unsigned int val;
+        }reg_gfx_ui_a8;
+        union
+        {
+            struct
+            {
+                unsigned int gfx_ui_hphase:6;
+                unsigned int reserved1:2;
+                unsigned int gfx_ui_vphase:6;
+                unsigned int reserved2:18;
+            }bits;
+            unsigned int val;
+        }reg_gfx_ui_phase;
+
+        union
+        {
+            struct
+            {
+                unsigned int gfx_ui_hcoeff_gid:4;
+                unsigned int gfx_ui_vcoeff_gid:4;
+                unsigned int reserved1:24;
+            }bits;
+            unsigned int val;
+        }reg_gfx_ui_coeff_gid;
+
+}df_gfx_reg;
+
+
+typedef struct _DF_REG_PARA_
+{
+	df_ctrl_reg		Ctrl;
+	df_gfx_reg		Gfx[2];
+	//df_video1_reg		Video1;
+	//df_video2_reg		Video2;
+	//df_video3_reg		Video3;
+	df_compositor_reg	Comp;
+	//df_hd2sd_reg		HD2SD;
+	df_outif_reg		OutIF[2];
+}df_reg_para;
+
+#endif
+
diff '--exclude=.svn' -Naur u-boot-2011.06_original/drivers/cnc1900/df/hdmi_sw_hw_if.h u-boot-2011.06/drivers/cnc1900/df/hdmi_sw_hw_if.h
